aboutsummaryrefslogtreecommitdiff
path: root/util/test_multiplayer.sh
diff options
context:
space:
mode:
Diffstat (limited to 'util/test_multiplayer.sh')
-rwxr-xr-xutil/test_multiplayer.sh26
1 files changed, 20 insertions, 6 deletions
diff --git a/util/test_multiplayer.sh b/util/test_multiplayer.sh
index 9fb894a30..5ffc044e0 100755
--- a/util/test_multiplayer.sh
+++ b/util/test_multiplayer.sh
@@ -20,7 +20,7 @@ waitfor () {
}
gdbrun () {
- gdb -q -ex 'set confirm off' -ex 'r' -ex 'bt' -ex 'quit' --args "$@"
+ gdb -q -batch -ex 'set confirm off' -ex 'r' -ex 'bt' --args "$@"
}
[ -e $minetest ] || { echo "executable $minetest missing"; exit 1; }
@@ -33,17 +33,27 @@ printf '%s\n' >$testspath/client1.conf \
enable_{sound,minimap,shaders}=false
printf '%s\n' >$testspath/server.conf \
- max_block_send_distance=1
+ max_block_send_distance=1 devtest_unittests_autostart=true
cat >$worldpath/worldmods/test/init.lua <<"LUA"
core.after(0, function()
io.close(io.open(core.get_worldpath() .. "/startup", "w"))
end)
-core.register_on_joinplayer(function(player)
- io.close(io.open(core.get_worldpath() .. "/player_joined", "w"))
+local function callback(test_ok)
+ if not test_ok then
+ io.close(io.open(core.get_worldpath() .. "/test_failure", "w"))
+ end
+ io.close(io.open(core.get_worldpath() .. "/done", "w"))
core.request_shutdown("", false, 2)
-end)
+end
+if core.settings:get_bool("devtest_unittests_autostart") then
+ unittests.on_finished = callback
+else
+ core.register_on_joinplayer(function() callback(true) end)
+end
LUA
+printf '%s\n' >$worldpath/worldmods/test/mod.conf \
+ name=test optional_depends=unittests
echo "Starting server"
gdbrun $minetest --server --config $conf_server --world $worldpath --gameid $gameid 2>&1 | sed -u 's/^/(server) /' &
@@ -51,10 +61,14 @@ waitfor $worldpath/startup
echo "Starting client"
gdbrun $minetest --config $conf_client1 --go --address 127.0.0.1 2>&1 | sed -u 's/^/(client) /' &
-waitfor $worldpath/player_joined
+waitfor $worldpath/done
echo "Waiting for client and server to exit"
wait
+if [ -f $worldpath/test_failure ]; then
+ echo "There were test failures."
+ exit 1
+fi
echo "Success"
exit 0